/*
 * Copyright (c) 1989, 1993
 *	The Regents of the University of California.  All rights reserved.
 * (c) UNIX System Laboratories, Inc.
 * All or some portions of this file are derived from material licensed
 * to the University of California by American Telephone and Telegraph
 * Co. or Unix System Laboratories, Inc. and are reproduced herein with
 * the permission of UNIX System Laboratories, Inc.
 *
 * This code is derived from software contributed to Berkeley by
 * Paul Borman at Krystal Technologies.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)ctype.h	8.4 (Berkeley) 1/21/94
 *      $FreeBSD: src/include/ctype.h,v 1.15 1999/12/17 15:12:02 phantom Exp $
 */

#ifndef _CTYPE_H_
#define	_CTYPE_H_

/*
 * XXX <runetype.h> brings massive namespace pollution (rune_t and struct
 * member names).
 */
#include <runetype.h>

__BEGIN_DECLS
int	isalnum __P((int));
int	isalpha __P((int));
int	iscntrl __P((int));
int	isdigit __P((int));
int	isgraph __P((int));
int	islower __P((int));
int	isprint __P((int));
int	ispunct __P((int));
int	isspace __P((int));
int	isupper __P((int));
int	isxdigit __P((int));
int	tolower __P((int));
int	toupper __P((int));

#if !defined(_ANSI_SOURCE) && !defined(_POSIX_SOURCE)
int	digittoint __P((int));
int	isascii __P((int));
int	isblank __P((int));
int	ishexnumber __P((int));
int	isideogram __P((int));
int	isnumber __P((int));
int	isphonogram __P((int));
int	isrune __P((int));
int	isspecial __P((int));
int	toascii __P((int));
#endif
__END_DECLS

#define	isalnum(c)	__istype((c), _CTYPE_A|_CTYPE_D)
#define	isalpha(c)	__istype((c), _CTYPE_A)
#define	iscntrl(c)	__istype((c), _CTYPE_C)
#define	isdigit(c)	__isctype((c), _CTYPE_D) /* ANSI -- locale independent */
#define	isgraph(c)	__istype((c), _CTYPE_G)
#define	islower(c)	__istype((c), _CTYPE_L)
#define	isprint(c)	__istype((c), _CTYPE_R)
#define	ispunct(c)	__istype((c), _CTYPE_P)
#define	isspace(c)	__istype((c), _CTYPE_S)
#define	isupper(c)	__istype((c), _CTYPE_U)
#define	isxdigit(c)	__isctype((c), _CTYPE_X) /* ANSI -- locale independent */
#define	tolower(c)	__tolower(c)
#define	toupper(c)	__toupper(c)

#if !defined(_ANSI_SOURCE) && !defined(_POSIX_SOURCE)
#define	digittoint(c)	__maskrune((c), 0xFF)

/* XXX the following macros are not backed up by functions. */
#ifdef _COMPAT_RUNE
#define	isascii(c)	(((c) & ~0x7F) == 0)
#define	isblank(c)	__istype((c), _CTYPE_B)
#define	ishexnumber(c)	__istype((c), _CTYPE_X)
#define	isideogram(c)	__istype((c), _CTYPE_I)
#define	isnumber(c)	__istype((c), _CTYPE_D)
#define	isphonogram(c)	__istype((c), _CTYPE_Q)
#define	isrune(c)	__istype((c), 0xFFFFFF00L)
#define	isspecial(c)	__istype((c), _CTYPE_T)
#define	toascii(c)	((c) & 0x7F)
#endif
#endif

#endif /* !_CTYPE_H_ */
