#	from: @(#)Makefile.inc	5.1 (Berkeley) 2/18/91
#	$NetBSD: Makefile.inc,v 1.16 1999/02/24 15:05:20 drochner Exp $

# locale sources
.PATH: ${ARCHDIR}/locale ${.CURDIR}/locale

.if !defined(WITH_RUNE)
WITH_RUNE= no
.endif
.if !defined(DLRUNE)
DLRUNE= no
.endif

SRCS+=	_def_messages.c _def_monetary.c _def_numeric.c _def_time.c \
	localeconv.c nl_langinfo.c setlocale.c setlocale_sb.c setlocale_mb.c \
	collate.c collcmp.c

.if ${WITH_RUNE} != "yes"
SRCS+=	ctypeio.c wcsmbs_sb.c
.else
# WITH_RUNE == "yes"
SRCS+=	multibyte.c iswctype.c tolowermb.c touppermb.c \
	runetable.c localeconv.c runenone.c rune.c \
	setrunelocale.c runeglue.c runetypemb.c timelocal.c wcswidth.c
CPPFLAGS+= -DWITH_RUNE
.if ${DLRUNE} == "yes"
MODULE_SHLIB_MAJOR!=	. ${.CURDIR}/../localemod/shlib_version; echo $$major
CPPFLAGS+= -DDLRUNE -DRUNEMOD_MAJOR=${MODULE_SHLIB_MAJOR}
.if !defined(OBJECT_FMT) || ${OBJECT_FMT} == "aout"
CPPFLAGS+= -DDLRUNE_AOUT
.endif # a.out
.else
# DLRUNE != "yes"
SRCS+= big5.c euc.c euctw.c iso2022.c mskanji.c utf2.c utf8.c
CPPFLAGS+= -DXPG4
.endif # DLRUNE != "yes"
.endif # WITH_RUNE == "yes"

MAN+=	nl_langinfo.3 setlocale.3

MLINKS+=setlocale.3 localeconv.3

MAN+=	iswalnum.3 towlower.3 wmemchr.3

MLINKS+=iswalnum.3 iswalpha.3 iswalnum.3 iswblank.3 \
	iswalnum.3 iswcntrl.3 iswalnum.3 iswdigit.3 \
	iswalnum.3 iswgraph.3 iswalnum.3 iswlower.3 \
	iswalnum.3 iswprint.3 iswalnum.3 iswpunct.3 \
	iswalnum.3 iswspace.3 iswalnum.3 iswupper.3 \
	iswalnum.3 iswxdigit.3
MLINKS+=towlower.3 towupper.3
MLINKS+=wmemchr.3 wmemcmp.3 wmemchr.3 wmemcpy.3 \
	wmemchr.3 wmemmove.3 wmemchr.3 wmemset.3 \
	wmemchr.3 wcscat.3 wmemchr.3 wcschr.3 \
	wmemchr.3 wcscmp.3 wmemchr.3 wcscpy.3 \
	wmemchr.3 wcscspn.3 wmemchr.3 wcslen.3 \
	wmemchr.3 wcsncat.3 wmemchr.3 wcsncmp.3 \
	wmemchr.3 wcsncpy.3 wmemchr.3 wcspbrk.3 \
	wmemchr.3 wcsrchr.3 wmemchr.3 wcsspn.3 \
	wmemchr.3 wcsstr.3
