/*-
 * Copyright (c)2000 Citrus Project,
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	$Id: setlocale_mb.c,v 1.2 2000/11/22 19:22:56 itojun Exp $
 */


#include <sys/cdefs.h>
#include "namespace.h"
#define __SETLOCALE_SOURCE__
#include <locale.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define _BSD_RUNE_T_    wchar_t
#define _BSD_CT_RUNE_T_ wchar_t
#include "runetype.h"

#define __SETLOCALE_MB(len)						\
char * __CONCAT(__setlocale_mb_len_max_,len) __P((int, const char *));	\
char *__setlocale_mb __P((int, const char *));				\
									\
char *									\
__CONCAT(__setlocale_mb_len_max_,len)(category, locale)			\
	int category;							\
	const char *locale;						\
{									\
	__mb_len_max_runtime = len;					\
									\
	return __setlocale(category, locale);				\
}									\
/* XXX: backward binary compatible code for the previous XPG4DL */	\
char *									\
__setlocale_mb(category, locale)					\
	int category;							\
	const char *locale;						\
{									\
	return __CONCAT(__setlocale_mb_len_max_,len)(category, locale);	\
}

__SETLOCALE_MB(32)
