#	$OpenBSD: Makefile.inc,v 1.4 1998/11/20 11:18:42 d Exp $

# locale sources
.PATH: ${LIBCSRCDIR}/arch/${MACHINE_ARCH}/locale ${LIBCSRCDIR}/locale

.if !defined(WITH_RUNE)
WITH_RUNE= no
.endif
.if !defined(DLRUNE)
DLRUNE= no
.endif

SRCS+=	_def_messages.c _def_monetary.c _def_numeric.c _def_time.c \
       localeconv.c nl_langinfo.c setlocale.c setlocale_sb.c \
       collate.c collcmp.c

.if ${WITH_RUNE} != "yes"
SRCS+= ctypeio.c wcsmbs_sb.c
.else
# WITH_RUNE == "yes"
SRCS+= multibyte.c iswctype.c tolowermb.c touppermb.c \
       runetable.c lconv.c localeconv.c runenone.c rune.c \
       setrunelocale.c runeglue.c runetypemb.c \
       wcswidth.c
CPPFLAGS+= -DWITH_RUNE
.if ${DLRUNE} == "yes"
CPPFLAGS+= -DDLRUNE -DRUNEMOD_MAJOR=3
#      Unreferenced global symbol is not contained in the .dynamic
#      section of an executable.
#      Thus, old executable with new libc which contains such symbol
#      will not work.
#      To keep binary compatibility, my "dlXXX" function is needed...
.if defined(OBJECT_FMT) && ${OBJECT_FMT} == "ELF"
.if !defined(ELFSIZE)
ELFSIZE=32
.endif
CPPFLAGS+= -DNEED_LOCALE_DL -D__ELFSIZE=${ELFSIZE}
CPPFLAGS+= -I${.CURDIR}/../../libexec/ld.elf_so
SRCS+=     locale_dl.c
.else
# OBJECT_FMT != "ELF"
CPPFLAGS+= -DDLRUNE_AOUT
.endif # OBJECT_FMT != "ELF"
.else
# DLRUNE != "yes"
SRCS+= big5.c euc.c euctw.c iso2022.c mskanji.c utf2.c
CPPFLAGS+= -DXPG4
.endif # DLRUNE != "yes"
.endif # WITH_RUNE == "yes"


MAN+=	nl_langinfo.3 setlocale.3
MLINKS+=setlocale.3 localeconv.3
