/*	$OpenBSD: ansi.h,v 1.8 1997/07/07 05:56:34 millert Exp $	*/
/*	$NetBSD: ansi.h,v 1.6 1996/11/15 22:38:45 jtc Exp $	*/

/*-
 * Copyright (c) 1990, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)ansi.h	8.2 (Berkeley) 1/4/94
 */

#ifndef	_ANSI_H_
#define	_ANSI_H_

/*
 * Types which are fundamental to the implementation and may appear in
 * more than one standard header are defined here.  Standard headers
 * then use:
 *	#ifdef	_BSD_SIZE_T_
 *	typedef	_BSD_SIZE_T_ size_t;
 *	#undef	_BSD_SIZE_T_
 *	#endif
 */
#define	_BSD_CLOCK_T_	int			/* clock() */
#define	_BSD_PTRDIFF_T_	long			/* ptr1 - ptr2 */
#define	_BSD_SIZE_T_	unsigned long		/* sizeof() */
#define	_BSD_SSIZE_T_	long			/* byte count or error */
#define	_BSD_TIME_T_	int			/* time() */
typedef struct {
	char *base;
	int offset;
	int pad;
} __va_list;
#define	_BSD_VA_LIST_	__va_list		/* va_list */
#define _BSD_CLOCKID_T_	int
#define _BSD_TIMER_T_	int

/*
 * Types for the Multibyte Support Extension.
 */
#define	_BSD_WCHAR_T_	int			/* wchar_t */
#define _BSD_WINT_T_	int			/* wint_t */
/*
 * mbstate_t is opaque object.
 * Real mbstate_t is defined in other position, and depend on
 * each of wc/mb encoding schemes.
 */
typedef union {
	char __funyu[128];
#ifdef __GNUC__
	long long __align;
#else
	long __align;
#endif
} __mbstate_t;
#define _BSD_MBSTATE_T_		__mbstate_t	/* mbstate_t */


#endif	/* _ANSI_H_ */
