# $Id: make-links.sh,v 1.28 2001/01/16 10:32:47 minoura Exp $


if [ x"$1" = x"-d" ]; then
  find . -type l -exec echo 'remove {}@' \; -exec rm {} \;
  exit 0
fi


make_links () {
  local pwd entry from to i j

  echo "making links for $dst:"
  for i in $common_lists $os_lists; do
    eval entry='$'entry__"$i"; eval entry=\"$entry\"
    eval  from='$'from__"$i" ; eval  from=\"$from\"
    eval    to='$'to__"$i"   ; eval    to=\"$to\"
    pwd=`pwd`
    echo "  $to -> $from"
    for j in $entry; do
      if [ -e $to/$j ]; then
        if [ -h $to/$j ]; then
          echo "    making $j (relinked)"
          ln -sf $from/$j $to/$j
        else
          echo "    $j already exist (not changed)"
        fi
      else
        if [ -h $to/$j ]; then
          echo "    making $j (relinked)"
        else
          echo "    making $j"
        fi
        ln -sf $from/$j $to/$j
      fi
    done
  done
  echo
}


#
# common part across NetBSD and OpenBSD.
#
common_lists='libc_locale libc_string libc_iconv include include_runes libintl mklocale
              mklocale_data colldef colldef_data'
 from__libc_locale='../../../../FreeBSD/lib/libc/locale'
   to__libc_locale='$dst/lib/libc/locale'
entry__libc_locale='big5.c euc.c euctw.c iso2022.c iso2022.h iswctype.c
                    mskanji.c multibyte.c rune.c
		    collate.c collate.h collcmp.c rune_local.h
                    runenone.c runetable.c runetypemb.c setlocale.h
                    setrunelocale.c tolowermb.c touppermb.c utf2.c utf8.c
		    wcswidth.c'
 from__libc_string='../../../../FreeBSD/lib/libc/string'
   to__libc_string='$dst/lib/libc/string'
entry__libc_string='strcoll.3 strcoll.c strxfrm.3 strxfrm.c
                    wcscat.c wcschr.c wcscmp.c wcscpy.c wcscspn.c wcslen.c
                    wcsncat.c wcsncmp.c wcsncpy.c wcspbrk.c wcsrchr.c
                    wcsspn.c wcsstr.c wmemchr.c wmemcmp.c
                    wmemcpy.c wmemmove.c wmemset.c'
 from__libc_iconv='../../../../FreeBSD/lib/libc/iconv'
   to__libc_iconv='$dst/lib/libc/iconv'
entry__libc_iconv='iconv.3 iconv.c iconv.h iconv_close.3 iconv_local.h
		   iconv_open.3'
 from__include='../../FreeBSD/include'
   to__include='$dst/include'
entry__include='wchar.h wctype.h'
 from__include_runes='../../../../FreeBSD/include'
   to__include_runes='$dst/lib/libc/locale'
entry__include_runes='rune.h runetype.h'
 from__libintl='../../../FreeBSD/lib/libintl'
   to__libintl='$dst/lib/libintl'
entry__libintl='gettext.c libintl.h libintl_local.h pathnames.h
		textdomain.c gettext.3'
 from__mklocale='../../../FreeBSD/usr.bin/mklocale'
   to__mklocale='$dst/usr.bin/mklocale'
entry__mklocale='ldef.h lex.l mklocale.1 yacc.y'
 from__mklocale_data='../../../../FreeBSD/share/mklocale'
   to__mklocale_data='$dst/share/locale/ctype'
entry__mklocale_data='Makefile.inc charset en_US.UTF-2.src 
		      en_US.UTF-8.src ja_JP.CTEXT.src
                      ja_JP.ISO-2022-JP-2.src ja_JP.ISO-2022-JP.src
                      ja_JP.SJIS.src en_US.ASCII.src en_US.DIS_8859-15.src
                      en_US.ISO_8859-1.src en_US.ISO_8859-2.src
                      en_US.ISO_8859-4.src ru_SU.ISO_8859-5.src
                      ru_SU.CP866.src ru_SU.KOI8-R.src uk_UA.KOI8-U.src
                      zh_TW.BIG5.src zh_TW.eucTW.src
		      ja_JP.eucJP.src ko_KR.eucKR.src zh_CN.eucCN.src'
 from__colldef='../../../FreeBSD/usr.bin/colldef'
   to__colldef='$dst/usr.bin/colldef'
entry__colldef='colldef.1 parse.y scan.l'
 from__colldef_data='../../../../FreeBSD/share/colldef'
   to__colldef_data='$dst/share/locale/collate'
entry__colldef_data='Makefile.inc cs_CZ.ISO_8859-2.src
                     de_DE.DIS_8859-15.src de_DE.ISO_8859-1.src
		     es_ES.DIS_8859-15.src es_ES.ISO_8859-1.src
		     is_IS.DIS_8859-15.src is_IS.ISO_8859-1.src
		     en_US.ASCII.src en_US.DIS_8859-15.src
		     en_US.ISO_8859-1.src en_US.ISO_8859-2.src
                     en_US.ISO_8859-4.src lt_LT.ISO_8859-4.src
		     map.CP866 map.DIS_8859-15
		     map.ISO_8859-1 map.ISO_8859-2
		     map.ISO_8859-4 map.ISO_8859-5
                     map.KOI8-R map.KOI8-U
		     ru_SU.CP866.src ru_SU.ISO_8859-5.src ru_SU.KOI8-R.src
                     sv_SE.DIS_8859-15.src sv_SE.ISO_8859-1.src
                     uk_UA.KOI8-U.src'


#
# for NetBSD
#
dst='NetBSD'
os_lists=''
make_links


#
# for OpenBSD
#
dst='OpenBSD'
os_lists='O_libc_locale O_include O_mklocale O_colldef O_localemod O_localemod_subdir O_share_locale O_timedef'
 from__O_libc_locale='../../../../NetBSD/lib/libc/locale'
   to__O_libc_locale='$dst/lib/libc/locale'
entry__O_libc_locale='_def_messages.c _def_monetary.c _def_numeric.c
                      _def_time.c ctypeio.c ctypeio.h locale_dl.c
                      localeconv.c nl_langinfo.3 nl_langinfo.c
                      runeglue.c setlocale.3 setlocale.c setlocale_sb.c
                      timelocal.c timelocale.h wcsmbs_sb.c'
 from__O_include='../../NetBSD/include'
   to__O_include='$dst/include'
entry__O_include='ctype.h locale.h'
 from__O_localemod='../../../NetBSD/lib/localemod'
   to__O_localemod='$dst/lib/localemod'
entry__O_localemod='Makefile'
 from__O_localemod_subdir='../../../../NetBSD/lib/localemod'
   to__O_localemod_subdir='$dst/lib/localemod'
entry__O_localemod_subdir='
                    BIG5/Makefile
                    EUC/Makefile
                    EUCTW/Makefile
                    ISO2022/Makefile
                    MSKanji/Makefile
                    UTF2/Makefile
                    UTF8/Makefile'
 from__O_share_locale='../../../NetBSD/share/locale'
   to__O_share_locale='$dst/share/locale'
entry__O_share_locale='Makefile'
 from__O_timedef='../../../NetBSD/share/locale/time'
   to__O_timedef='$dst/share/locale/time'
entry__O_timedef='Makefile compile_time da_DK.ISO_8859-1.src
		  de_AT.ISO_8859-1.src de_DE.ISO_8859-1.src
		  en_GB.ISO_8859-1.src en_US.ISO_8859-1.src
		  es_ES.ISO_8859-1.src fi_FI.ISO_8859-1.src
		  fr_FR.ISO_8859-1.src hr_HR.ISO_8859-2.src
		  hu_HU.ISO_8859-2.src is_IS.ISO_8859-1.src
		  it_IT.ISO_8859-1.src ja_JP.EUC.src ja_JP.JIS.src
		  ja_JP.SJIS.src ko_KR.EUC.src la_LN.ISO_8859-1.src
		  nl_NL.ISO_8859-1.src no_NO.ISO_8859-1.src
		  pl_PL.ISO_8859-2.src pt_PT.ISO_8859-1.src
		  ru_SU.CP866.src ru_SU.KOI8-R.src sl_SI.ISO_8859-2.src
		  sv_SE.ISO_8859-1.src zh_CN.EUC.src zh_TW.Big5.src'

make_links


# end of file
