#! /bin/sh

DIRS="etc_mtree include lib lib_libc share sys usr_bin"
  DIR_etc_mtree="etc/mtree/"
FILES_etc_mtree="NetBSD.dist"
  DIR_include="include/"
FILES_include="Makefile ctype.h locale.h paths.h stddef.h stdlib.h"
  DIR_lib="lib/"
FILES_lib="Makefile"
  DIR_lib_libc="lib/libc/"
FILES_lib_libc="Makefile include/ locale/ stdlib/ string/ nls/"
  DIR_share="share/"
FILES_share="Makefile"
  DIR_usr_bin="usr.bin/"
FILES_usr_bin="Makefile"

CPU="alpha arm26 arm32 i386 m68k mips pc532 powerpc sh3 sparc sparc64 vax"
DIR_sys=
for i in `echo $CPU`; do
  DIR_sys="$DIR_sys sys/arch/$i/include/"
done
FILES_sys="ansi.h"


if [ $# = 0 -o $# -gt 2 ]; then
    echo "usage: $0 <srcdir> [<dstdir>]" 1>&2
    echo "  srcdir: NetBSD source directory (e.g. /usr/src)" 1>&2
    echo "  dstdir: destination directory (default: /tmp/cvs-import)" 1>&2
    exit 1
fi

SRCDIR=$1
DSTDIR=$2
if [ x$DSTDIR = x"" ]; then DSTDIR=/tmp/cvs-import; fi

for i in `echo $DIRS`; do
  for j in `eval "echo \\\$DIR_$i"`; do
    files=`(cd $SRCDIR; eval echo \\\$j)`
    for k in `echo $files`; do
      echo $k: 1>&2
      if [ ! -d $DSTDIR/$k ]; then
        echo "  (new directory)" 1>&2
        mkdir -p $DSTDIR/$k
      fi
      for l in `eval "echo \\\$FILES_$i"`; do
        if [ -d $SRCDIR/$k$l ]; then
          echo "  copy directory $k$l" 1>&2
          cp -R $SRCDIR/$k$l $DSTDIR/$k$l
        else
          echo "  copy file $k$l" 1>&2
          cp $SRCDIR/$k$l $DSTDIR/$k
        fi
      done
    done
  done
done
